package com.csc.library.process;


import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import com.csc.library.utilities.CheckNull;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;

public class EmployeeImpProp implements EmployeeImportField {
	
	private String employeeid ;
	private String companyid ;
	private String fullname ;
	private String gender ;
	private String company ;
	private String employee_group ;
	private String personal_id ;
	private String position ;
	private String branch ;
	private String department ;
	private String division ;
	private String section ;
	private String sub_section1 ;
	private String sub_section2 ;
	private String working_area ;
	private String boss_1 ;
	private String boss_2 ;
	private String boss_3 ;
	private String boss_4 ;
	private String boss_5 ;
	private String status ;
	private String nationality ;
	private String privilege ;
	private String resign_date ;
	private String startdate ;
	private String email ;
	private String passportid ;
	private String birthday ;
	private String telephone ;

	private String bossid_1 ;
	private String bossid_2 ;
	private String bossid_3 ;
	private String bossid_4 ;
	private String bossid_5 ;
	
	
	public EmployeeImpProp(){
		
	}
	
	public EmployeeImpProp(String raw){
		try {
			String ls[] = raw.split("\\|");
			
			if(ls.length >= TELEPHONE){
				setEmployeeid(getStringData(ls,EMPLOYEEID));
				setCompanyid(getStringData(ls,COMPANYID));
				setFullname(getStringData(ls,FULLNAME));
				setGender(getStringData(ls,GENDER));
				setCompany(getStringData(ls,COMPANY));
				setEmployee_group(getStringData(ls,EMPLOYEE_GROUP));
				setPersonal_id(getStringData(ls,PERSONAL_ID));
				setPosition(getStringData(ls,POSITION));
				setBranch(getStringData(ls,BRANCH));
				setDepartment(getStringData(ls,DEPARTMENT));
				setDivision(getStringData(ls,DIVISION));
				setSection(getStringData(ls,SECTION));
				setSub_section1(getStringData(ls,SUB_SECTION1));
				setSub_section2(getStringData(ls,SUB_SECTION2));
				setWorking_area(getStringData(ls,WORKING_AREA));
				setBoss_1(getStringData(ls,BOSS_1));
				setBoss_2(getStringData(ls,BOSS_2));
				setBoss_3(getStringData(ls,BOSS_3));
				setBoss_4(getStringData(ls,BOSS_4));
				setBoss_5(getStringData(ls,BOSS_5));
				setStatus(getStringData(ls,STATUS));
				setNationality(getStringData(ls,NATIONALITY));
				setPrivilege(getStringData(ls,PRIVILEGE));
				setResign_date(getStringData(ls,RESIGN_DATE));
				setStartdate(getStringData(ls,STARTDATE));
				
				setEmail(getStringData(ls,EMAIL));
				setPassportid(getStringData(ls,PASSPORTID));
				setBirthday(getStringData(ls,BIRTHDATE));
				setTelephone(getStringData(ls,TELEPHONE));
				
				/* boss id */
				if(ls.length >= BOSSID_1){
					setBossid_1(getStringData(ls, BOSSID_1));
				}
				
				if(ls.length >= BOSSID_2){
					setBossid_2(getStringData(ls, BOSSID_2));
				}
				
				if(ls.length >= BOSSID_3){
					setBossid_3(getStringData(ls, BOSSID_3));
				}
				
				if(ls.length >= BOSSID_4){
					setBossid_4(getStringData(ls, BOSSID_4));
				}
				
				if(ls.length >= BOSSID_5){
					setBossid_5(getStringData(ls, BOSSID_5));
				}
				
				if(this.getEmployeeid() == null || this.getEmployeeid().equals("")){
					MyLog.error(this, "!! incorrect raw data after split into array !!"  + raw);
					for(String item : ls){
						System.out.print(item + ":");
					}
					MyLog.error(this, "!! end print error !!");
				}
				
				/*testing*/
				//genImportEmp(ls);
			}else{
				MyLog.error(this, "!! raw data is incorrect !! " + ls);
			}
			
			
		}catch(Exception e){
			MyLog.error(this, e);
		}
	}
	
	/*testing*/
	private void genImportEmpFile(String ls[]){
		try {
			setEmail(getFullname().substring(0, 1).toLowerCase() 
					+ getFullname().substring(getFullname().indexOf(" ")).trim().toLowerCase() + "@peninsula.com");
			writetextfile(
					getEmployeeid() + "|" +
					getCompanyid() + "|" +
					getFullname() + "|" +
					getStringData(ls,GENDER) + "|" +
					getCompany() + "|" +
					getEmployee_group() + "|" +
					getPersonal_id() + "|" +
					getPosition() + "|" +
					getBranch() + "|" +
					getDepartment() + "|" +
					getDivision() + "|" +
					getSection() + "|" +
					getSub_section1() + "|" +
					getSub_section2() + "|" +
					getWorking_area() + "|" +
					getBoss_1() + "|" +
					getBoss_2() + "|" +
					getBoss_3() + "|" +
					getBoss_4() + "|" +
					getBoss_5() + "|" +
					getStringData(ls,STATUS) + "|" +
					getNationality() + "|" +
					getPrivilege() + "|" +
					getResign_date() + "|" +
					getStartdate() + "|" +
					getEmail() + "|" +
					getPassportid() + "|" +
					getBirthday() + "|" +
					getTelephone() + "|" +
					getBossid_1() + "|" +
					getBossid_2() + "|" +
					getBossid_3() + "|" +
					getBossid_4() + "|" +
					getBossid_5()
					
					);
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	/*testing*/
	private void writetextfile(String content){
		BufferedWriter bw = null;
		FileWriter fw = null;
		try {
			File file = new File("/Users/CSC/MyDrive/zeeme_emp_data.txt");

			if (!file.exists()) {
				file.createNewFile();
			}

			fw = new FileWriter(file.getAbsoluteFile(), true);
			bw = new BufferedWriter(fw);

			bw.write(content + "\n");

			System.out.println("Done");				
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				if (bw != null)
					bw.close();

				if (fw != null)
					fw.close();

			} catch (IOException ex) {
				ex.printStackTrace();
			}
		}
	}
	
	private String getStringData(String arr[], int index){
		try {
			return CheckNull.getInstance().chkNullString(arr[index].trim());
		}catch(Exception e){
			MyLog.error(this, "!! index out of bound : " + index + " >> " + arr);
		}
		return "";
	}
	
	public String getEmployeeid() {
		return employeeid;
	}
	public void setEmployeeid(String employeeid) {
		this.employeeid = employeeid;
	}
	public String getCompanyid() {
		return companyid;
	}
	public void setCompanyid(String companyid) {
		this.companyid = companyid;
	}
	public String getFullname() {
		return fullname;
	}
	public void setFullname(String fullname) {
		this.fullname = fullname;
	}
	public String getGender() {
		return String.valueOf(convertGender());
	}
	public void setGender(String gender) {
		this.gender = gender;
	}
	public String getCompany() {
		return company;
	}
	public void setCompany(String company) {
		this.company = company;
	}
	public String getEmployee_group() {
		return employee_group;
	}
	public void setEmployee_group(String employee_group) {
		this.employee_group = employee_group;
	}
	public String getPersonal_id() {
		return personal_id;
	}
	public void setPersonal_id(String personal_id) {
		this.personal_id = personal_id;
	}
	public String getPosition() {
		return position;
	}
	public void setPosition(String position) {
		this.position = position;
	}
	public String getBranch() {
		return branch;
	}
	public void setBranch(String branch) {
		this.branch = branch;
	}
	public String getDepartment() {
		return department;
	}
	public void setDepartment(String department) {
		this.department = department;
	}
	public String getDivision() {
		return division;
	}
	public void setDivision(String division) {
		this.division = division;
	}
	public String getSection() {
		return section;
	}
	public void setSection(String section) {
		this.section = section;
	}
	public String getSub_section1() {
		return sub_section1;
	}
	public void setSub_section1(String sub_section1) {
		this.sub_section1 = sub_section1;
	}
	public String getSub_section2() {
		return sub_section2;
	}
	public void setSub_section2(String sub_section2) {
		this.sub_section2 = sub_section2;
	}
	public String getWorking_area() {
		return working_area;
	}
	public void setWorking_area(String working_area) {
		this.working_area = working_area;
	}
	public String getBoss_1() {
		return boss_1;
	}
	public void setBoss_1(String boss_1) {
		this.boss_1 = boss_1;
	}
	public String getBoss_2() {
		return boss_2;
	}
	public void setBoss_2(String boss_2) {
		this.boss_2 = boss_2;
	}
	public String getBoss_3() {
		return boss_3;
	}
	public void setBoss_3(String boss_3) {
		this.boss_3 = boss_3;
	}
	public String getBoss_4() {
		return boss_4;
	}
	public void setBoss_4(String boss_4) {
		this.boss_4 = boss_4;
	}
	public String getBoss_5() {
		return boss_5;
	}
	public void setBoss_5(String boss_5) {
		this.boss_5 = boss_5;
	}
	public String getStatus() {
		return String.valueOf(convertWorkStatus());
	}
	public void setStatus(String status) {
		this.status = status;
	}
	public String getNationality() {
		return nationality;
	}
	public void setNationality(String nationality) {
		this.nationality = nationality;
	}
	public String getPrivilege() {
		return privilege;
	}
	public void setPrivilege(String privilege) {
		this.privilege = privilege;
	}
	public String getResign_date() {
		if(resign_date == null || resign_date.equals("")){
			return "2100-12-31"; /* default */
		}else{
			return resign_date;
		}
	}
	public void setResign_date(String resign_date) {
		this.resign_date = resign_date;
	}
	public String getEmail() {
		return email;
	}
	public void setEmail(String email) {
		this.email = email;
	}
	public String getPassportid() {
		return passportid;
	}
	public void setPassportid(String passportid) {
		this.passportid = passportid;
	}
	public String getBirthday() {
		return birthday;
	}
	public void setBirthday(String birthday) {
		this.birthday = birthday;
	}
	public String getTelephone() {
		return telephone;
	}
	public void setTelephone(String telephone) {
		this.telephone = telephone;
	}
	public String getBossid_1() {
		return bossid_1;
	}

	public void setBossid_1(String bossid_1) {
		this.bossid_1 = bossid_1;
	}

	public String getBossid_2() {
		return bossid_2;
	}

	public void setBossid_2(String bossid_2) {
		this.bossid_2 = bossid_2;
	}

	public String getBossid_3() {
		return bossid_3;
	}

	public void setBossid_3(String bossid_3) {
		this.bossid_3 = bossid_3;
	}

	public String getBossid_4() {
		return bossid_4;
	}

	public void setBossid_4(String bossid_4) {
		this.bossid_4 = bossid_4;
	}

	public String getBossid_5() {
		return bossid_5;
	}

	public void setBossid_5(String bossid_5) {
		this.bossid_5 = bossid_5;
	}
	
	public String getFirstName(){
		try {
			if(this.fullname != null && this.fullname.length() > 0){
				String[] f = this.fullname.split(" ");
				
				return f[0];
			}
		}catch(Exception e){
			MyLog.error(this, e);
		}
		return "";
	}
	
	public String getLastName(){
		try {
			if(this.fullname != null && this.fullname.length() > 0){
				String[] f = this.fullname.split(" ");
				
				return f[f.length-1];
			}
		}catch(Exception e){
			MyLog.error(this, e);
		}
		return "";
	}
	
	public int convertGender(){
		try {
			if(this.gender.equals("M")){
				return MALE ;
			}else{
				return FEMALE ;
			}
		}catch(Exception e){
			MyLog.error(this, e);
		}
		return MALE ;
	}
	
	public int convertWorkStatus(){
		try {
			if(this.status.equals("A") || this.status.equals("V")){
				return 1 ;
			}
		}catch(Exception e){
			MyLog.error(this, e);
		}
		return 0 ;
	}

	public String getStartdate() {
		return startdate;
	}

	public void setStartdate(String startdate) {
		this.startdate = startdate;
	}
	
}
