package com.csc.library.process;


import com.csc.library.cinterface.ImportFromTrdInterface;
import com.csc.library.csecurity.CSecurity;
import com.csc.library.ftp.ConnectProp;
import com.csc.library.resource.SystemConfig;
import com.csc.library.utilities.FileUtils;

public class UpdateEmpFromTrdParty extends UpdateFromTRDParty {
	
	ConnectProp cnp ;

	public UpdateEmpFromTrdParty(){
	}
	
	public boolean process(String comp){
		try {
			initConfig(comp);
			if(loadFile(cnp)){
				updateEmpFromFile();
			}
		}catch(Exception e){
			e.printStackTrace();
			return false ;
		}
		return true ;
	}
	
	public boolean initConfig(String comp){
		try {
			
			ImportFromTrdInterface ift = SystemConfig.getImportFromTrdInstance(comp);
			 
			cnp = new ConnectProp();
			cnp.setAddress(ift.getEmpSourceURL());
			cnp.setUsername(ift.getEmpUserName());
			cnp.setPassword(CSecurity.newInstance().decrypt(ift.getEmpPassword()));
			cnp.setFilename(ift.getEmpSourceFileName());
			cnp.setProtocol(ift.getEmpProtocol());
			cnp.setPort(ift.getEmpSourcePort());
			cnp.setDirectory(ift.getEmpSourceDirectory());
			cnp.setTargetFolder(FileUtils.getCanonicalPath() 
					+ "/" 
					+ ift.getEmpTargetFolder());
			cnp.setTargetSubfolder(ift.getEmpTargetSubFolder());
			cnp.setTarget(FileUtils.getCanonicalPath() 
					+ "/" 
					+ ift.getEmpTargetFolder()
					+ ift.getEmpTargetSubFolder());
			
		}catch(Exception e){
			e.printStackTrace();
			return false ;
		}
		return true ;
	}
	
	public boolean updateEmpFromFile(){
		try {
			ImportEmpManager imp = ImportEmpManager.newInstance() ;
			imp.importFromFolder(cnp.getTarget(), ".txt", cnp.getTarget());
		}catch(Exception e){
			e.printStackTrace();
			return false;
		}
		return true ;
	}
	
}




