package com.csc.library.training.controller;

import com.csc.library.utilities.CheckNull;
import com.csc.library.utilities.MyLog;

public class EmpCourseProp implements EmpCourseImportField {
	private String companyid ;
	private String trainingid ;
	private String courseid ;
	private String sessid ;
	private String legacycode ;
	
	public static EmpCourseProp newInstance(String content){
		EmpCourseProp tp = new EmpCourseProp();
		tp.init(content);
		
		return tp;		
	}
	
	private void init(String raw){
		try {
			String ls[] = raw.split("\\|");
			
			setCompanyid(getStringData(ls,COMPANYID));
			setTrainingid(getStringData(ls,TRAININGID));
			setCourseid(getStringData(ls,COURSEID));
			setSessid(getStringData(ls,SESSION));
			setLegacycode(getStringData(ls, LEGACYCODE));
			
		}catch(Exception e){
			MyLog.error(this, e);
		}
	}
	
	private String getStringData(String arr[], int index){
		try {
			return CheckNull.getInstance().chkNullString(arr[index]);
		}catch(Exception e){
			MyLog.error(this, "!! index out of bound : " + index + " >> " + arr);
		}
		return "";
	}	
	
	public String getCompanyid() {
		return companyid;
	}
	public void setCompanyid(String companyid) {
		this.companyid = companyid;
	}
	public String getTrainingid() {
		return trainingid;
	}
	public void setTrainingid(String trainingid) {
		this.trainingid = trainingid;
	}
	public String getCourseid() {
		return courseid;
	}
	public void setCourseid(String courseid) {
		this.courseid = courseid;
	}
	public String getSessid() {
		return sessid;
	}
	public void setSessid(String sessid) {
		this.sessid = sessid;
	}
	public String getLegacycode() {
		return legacycode;
	}
	public void setLegacycode(String legacycode) {
		this.legacycode = legacycode;
	}	
	
	
}
