package com.csc.library.training.controller;

import javax.inject.Inject;

import com.csc.library.cdi.GetCdiInstance;
import com.csc.library.controller.NotificationController;
import com.csc.library.controller.NotificationController.NotificationResult;
import com.csc.library.entity.Trainee;
import com.csc.library.entity.TrainingCourse;
import com.csc.library.status.StatusResultMessage;
import com.csc.library.training.utilitis.TimeUtils;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;

public class SendNewCourseNotification {

	private NotificationController notifiedController ;
	
	public static SendNewCourseNotification sn ;
	
	public static SendNewCourseNotification newInstance(){
		if(sn == null) {
			sn = new SendNewCourseNotification();
		}
		
		return sn ;
	}

	public void send(Trainee te, TrainingCourse tc){
		try {
			
			CourseNotificationModel model = new CourseNotificationModel();
			model.setCompanyId(te.getCompanyid());
			model.setMemberId(te.getMemberid());
			
			CscCalendar cs = TimeUtils.getCscCalendar(tc.getStartdate(), tc.getStarttime());
			CscCalendar ce = TimeUtils.getCscCalendar(tc.getEnddate(), tc.getEndtime());
			
			model.setStartDate(TimeUtils.getDDMMYYYY(cs));
			model.setStartTime(TimeUtils.getHHMM(cs));
			model.setEndDate(TimeUtils.getDDMMYYYY(ce));
			model.setEndTime(TimeUtils.getHHMM(ce));
			model.setTitle(tc.getTitle());
			
			/*
			notifiedController = GetCdiInstance.of(NotificationController.class);
			notifiedController.createNotificationBuilder()
			*/
			//StatusResultMessage<NotificationResult> srm = 
			//		notifiedController.createNotificationBuilder(NotificationMode.N02)
					
			//	.setTitle("Course Available : " + model.getTitle())
			//	.setBody(model.getStartDate() + "  " + model.getStartTime() + "-" + model.getEndTime())
			//	.setData(model)
			//	.pushNotifiedToEmployeeHost(model.getCompanyId(), model.getMemberId());
		}catch(Exception e){
			MyLog.error(this, e);
		}
	}
	
	public class CourseNotificationModel{
		private String CompanyId ;
		private String MemberId ;
		private String StartDate ;
		private String StartTime ;
		private String EndDate ;
		private String EndTime ;
		private String Title ;
		
		public String getCompanyId() {
			return CompanyId;
		}
		public void setCompanyId(String companyId) {
			CompanyId = companyId;
		}
		public String getMemberId() {
			return MemberId;
		}
		public void setMemberId(String memberId) {
			MemberId = memberId;
		}
		public String getStartDate() {
			return StartDate;
		}
		public void setStartDate(String startDate) {
			StartDate = startDate;
		}
		public String getStartTime() {
			return StartTime;
		}
		public void setStartTime(String startTime) {
			StartTime = startTime;
		}
		public String getEndDate() {
			return EndDate;
		}
		public void setEndDate(String endDate) {
			EndDate = endDate;
		}
		public String getEndTime() {
			return EndTime;
		}
		public void setEndTime(String endTime) {
			EndTime = endTime;
		}
		public String getTitle() {
			return Title;
		}
		public void setTitle(String title) {
			Title = title;
		}
	}
}
