package com.csc.library.training.controller;

import com.csc.library.cinterface.ImportFromTrdInterface;
import com.csc.library.csecurity.CSecurity;
import com.csc.library.ftp.ConnectProp;
import com.csc.library.process.UpdateFromTRDParty;
import com.csc.library.resource.SystemConfig;
import com.csc.library.utilities.FileUtils;

public class UpdateCourseFromTrdParty extends UpdateFromTRDParty {
	
	ConnectProp cnp ;

	public UpdateCourseFromTrdParty(){
	}
	
	public boolean process(String comp){
		try {
			initConfig(comp);
			if(loadFile(cnp)){
				updateCourseFromFile();
			}
		}catch(Exception e){
			e.printStackTrace();
			return false ;
		}
		return true ;
	}
	
	public boolean initConfig(String comp){
		try {
			ImportFromTrdInterface ift = SystemConfig.getImportFromTrdInstance(comp);
			 
			cnp = new ConnectProp();
			cnp.setAddress(ift.getCourseSourceURL());
			cnp.setUsername(ift.getCourseUserName());
			cnp.setPassword(CSecurity.newInstance().decrypt(ift.getCoursePassword()));
			cnp.setFilename(ift.getCourseSourceFileName());
			cnp.setProtocol(ift.getCourseProtocol());
			cnp.setPort(ift.getCourseSourcePort());
			cnp.setDirectory(ift.getCourseSourceDirectory());
			cnp.setTargetFolder(FileUtils.getCanonicalPath() 
					+ "/" 
					+ ift.getCourseTargetFolder() );
			cnp.setTargetSubfolder(ift.getCourseTargetSubFolder());
			cnp.setTarget(FileUtils.getCanonicalPath() 
					+ "/" 
					+ ift.getCourseTargetFolder() 
					+ ift.getCourseTargetSubFolder());
			
		}catch(Exception e){
			e.printStackTrace();
			return false ;
		}
		return true ;
	}
	
	public boolean updateCourseFromFile(){
		try {
			ImportCourse imp = ImportCourse.newInstance() ;
			imp.importFromFolder(cnp.getTarget(), ".txt", cnp.getTarget());
		}catch(Exception e){
			e.printStackTrace();
			return false;
		}
		return true ;
	}
	
}




